

// synopsys translate_off
`timescale 1 ps / 1 ps
// synopsys translate_on

module mult (
    input  logic         clock,
    input  logic         reset,
    input  logic         enable,
    input  logic [255:0] dataa,
    input  logic [255:0] datab,
    output logic [511:0] result,
    output logic         result_valid
);

    localparam RESULT_DELAY = 3;

    lpm_mult lpm_mult_component (
        .clock  (clock),
        .dataa  (dataa),
        .datab  (datab),
        .result (result),
        .aclr   (reset),
        .clken  (1'b1),
        .sclr   (1'b0),
        .sum    (1'b0)
    );
    defparam
        lpm_mult_component.lpm_hint = "MAXIMIZE_SPEED=9",
        lpm_mult_component.lpm_pipeline = 3,
        lpm_mult_component.lpm_representation = "UNSIGNED",
        lpm_mult_component.lpm_type = "LPM_MULT",
        lpm_mult_component.lpm_widtha = 256,
        lpm_mult_component.lpm_widthb = 256,
        lpm_mult_component.lpm_widthp = 512;


    logic [1:0] enable_delay;

    always_ff @(posedge clock or posedge reset) begin
        if (reset) begin
            enable_delay <= '0;
        end
        else begin
            enable_delay[0] <= enable;
            enable_delay[1] <= enable_delay[0];
        end
    end

    assign result_valid = enable_delay[1];

endmodule

// ============================================================
// CNX file retrieval info
// ============================================================
// Retrieval info: PRIVATE: AutoSizeResult NUMERIC "1"
// Retrieval info: PRIVATE: B_isConstant NUMERIC "0"
// Retrieval info: PRIVATE: ConstantB NUMERIC "0"
// Retrieval info: PRIVATE: INTENDED_DEVICE_FAMILY STRING "Cyclone V"
// Retrieval info: PRIVATE: LPM_PIPELINE NUMERIC "3"
// Retrieval info: PRIVATE: Latency NUMERIC "1"
// Retrieval info: PRIVATE: SYNTH_WRAPPER_GEN_POSTFIX STRING "0"
// Retrieval info: PRIVATE: SignedMult NUMERIC "0"
// Retrieval info: PRIVATE: USE_MULT NUMERIC "1"
// Retrieval info: PRIVATE: ValidConstant NUMERIC "0"
// Retrieval info: PRIVATE: WidthA NUMERIC "256"
// Retrieval info: PRIVATE: WidthB NUMERIC "256"
// Retrieval info: PRIVATE: WidthP NUMERIC "512"
// Retrieval info: PRIVATE: aclr NUMERIC "0"
// Retrieval info: PRIVATE: clken NUMERIC "0"
// Retrieval info: PRIVATE: new_diagram STRING "1"
// Retrieval info: PRIVATE: optimize NUMERIC "1"
// Retrieval info: LIBRARY: lpm lpm.lpm_components.all
// Retrieval info: CONSTANT: LPM_HINT STRING "MAXIMIZE_SPEED=9"
// Retrieval info: CONSTANT: LPM_PIPELINE NUMERIC "3"
// Retrieval info: CONSTANT: LPM_REPRESENTATION STRING "UNSIGNED"
// Retrieval info: CONSTANT: LPM_TYPE STRING "LPM_MULT"
// Retrieval info: CONSTANT: LPM_WIDTHA NUMERIC "256"
// Retrieval info: CONSTANT: LPM_WIDTHB NUMERIC "256"
// Retrieval info: CONSTANT: LPM_WIDTHP NUMERIC "512"
// Retrieval info: USED_PORT: clock 0 0 0 0 INPUT NODEFVAL "clock"
// Retrieval info: USED_PORT: dataa 0 0 256 0 INPUT NODEFVAL "dataa[255..0]"
// Retrieval info: USED_PORT: datab 0 0 256 0 INPUT NODEFVAL "datab[255..0]"
// Retrieval info: USED_PORT: result 0 0 512 0 OUTPUT NODEFVAL "result[511..0]"
// Retrieval info: CONNECT: @clock 0 0 0 0 clock 0 0 0 0
// Retrieval info: CONNECT: @dataa 0 0 256 0 dataa 0 0 256 0
// Retrieval info: CONNECT: @datab 0 0 256 0 datab 0 0 256 0
// Retrieval info: CONNECT: result 0 0 512 0 @result 0 0 512 0
// Retrieval info: GEN_FILE: TYPE_NORMAL mult.v TRUE
// Retrieval info: GEN_FILE: TYPE_NORMAL mult.inc FALSE
// Retrieval info: GEN_FILE: TYPE_NORMAL mult.cmp FALSE
// Retrieval info: GEN_FILE: TYPE_NORMAL mult.bsf FALSE
// Retrieval info: GEN_FILE: TYPE_NORMAL mult_inst.v TRUE
// Retrieval info: GEN_FILE: TYPE_NORMAL mult_bb.v TRUE
// Retrieval info: LIB_FILE: lpm
